import { Declaration, Symbol } from 'typescript';
import { ExportDoc } from './ExportDoc';
import { ParameterContainer } from './ParameterContainer';
/**
 * This represents a call parameter of an exported function or of a method of a class or interface.
 * You can find them on the `FunctionExportDoc.parameters` or `MethodMemberDoc.parameters` properties.
 * They are generated by the call to `getParameters` service.
 */
export declare class ParameterDoc extends ExportDoc {
    container: ParameterContainer;
    docType: string;
    type: string;
    paramText: string;
    description: string;
    constructor(container: ParameterContainer, symbol: Symbol, declaration: Declaration);
}
