"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var getDeclarationTypeText_1 = require("../services/TsParser/getDeclarationTypeText");
var getDeclarationTypeText_2 = require("../services/TsParser/getDeclarationTypeText");
var getTypeText_1 = require("../services/TsParser/getTypeText");
var nodeToString_1 = require("../services/TsParser/nodeToString");
var ExportDoc_1 = require("./ExportDoc");
/**
 * This represents a call parameter of an exported function or of a method of a class or interface.
 * You can find them on the `FunctionExportDoc.parameters` or `MethodMemberDoc.parameters` properties.
 * They are generated by the call to `getParameters` service.
 */
var ParameterDoc = (function (_super) {
    __extends(ParameterDoc, _super);
    function ParameterDoc(container, symbol, declaration) {
        var _this = _super.call(this, container.moduleDoc, symbol, declaration) || this;
        _this.container = container;
        _this.docType = 'parameter';
        _this.type = getDeclarationTypeText_1.getDeclarationTypeText(_this.declaration, _this.namespacesToInclude);
        _this.paramText = getParamText(_this.declaration, _this.namespacesToInclude);
        _this.description = _this.content;
        _this.id = _this.container.id + "~" + _this.name;
        _this.aliases = (_this.container.aliases || []).map(function (alias) { return alias + "~" + _this.name; });
        return _this;
    }
    return ParameterDoc;
}(ExportDoc_1.ExportDoc));
exports.ParameterDoc = ParameterDoc;
function getParamText(parameter, namespacesToInclude) {
    var paramText = '';
    if (parameter.dotDotDotToken)
        paramText += '...';
    paramText += nodeToString_1.nodeToString(parameter.name);
    if (parameter.questionToken)
        paramText += '?';
    var type = parameter.type;
    if (type) {
        paramText += ': ' + getTypeText_1.getTypeText(type, namespacesToInclude);
    }
    var initializer = getDeclarationTypeText_2.getInitializer(parameter);
    if (initializer) {
        paramText += ' = ' + nodeToString_1.nodeToString(initializer);
    }
    return paramText.trim();
}
//# sourceMappingURL=ParameterDoc.js.map